﻿using System;


namespace SimpleTimers
{
    class Program
    {
        static void Main(string[] args)
        {
            System.Timers.Timer timerSystem = new System.Timers.Timer(1500);
            timerSystem.Elapsed += TimerSystem_Elapsed;
            //  timerSystem.AutoReset = false; //If we want one shot
            timerSystem.Start();
            Console.ReadLine();
            timerSystem.Stop();
       
            TimerState ts = new TimerState() { Counter = 0 };
            System.Threading.Timer timerThreading = new System.Threading.Timer(new System.Threading.TimerCallback(TimerTick), ts, 3000, 1000);
            Console.ReadLine();
            timerThreading.Change(System.Threading.Timeout.Infinite, 0);
            Console.WriteLine("The End");
        }

        private static void TimerTick(object timerState)
        {
            TimerState tState = (TimerState)timerState;
            System.Threading.Interlocked.Increment(ref tState.Counter);
            Console.WriteLine($"Timer tick set counter to: {tState.Counter}");
        }

        private static void TimerSystem_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            Console.WriteLine("System timer tick tok...");
        }
        class TimerState
        {
            public int Counter;
        }

    }
}
